module MyRepresentatives
  module ACT
    class WebIndex
      attr_accessor :index_url, :document, :representative_documents

      def initialize
        @logger = Logger.new(STDOUT)
        @index_url                = "https://www.parliament.act.gov.au/members/current"
        @document                 = find_representatives
        @representative_documents = []
        representative_documents_from_document
      end


      private

        def find_representatives
          begin
            request = open(@index_url)
            Nokogiri::HTML(request)
          rescue SocketError => err
            @logger.debug("Unable to connect to #{@index_url}")
            raise err
          end
        end

        def representative_documents_from_document
          table = @document.css("table.tablesorter")

          table.css("tbody").css("tr").each do |row|
            @representative_documents << row unless row.text.strip.empty?
          end
        end

    end # WebIndex
  end # ACT
end # MyRep
