module MyRepresentatives
  module Commonwealth
    class MergeUpper
      attr_accessor :csv_people, :web_people, :email_people, :people

      def initialize
        @csv_people   = MyRepresentatives::Commonwealth::CSVUpper.new.people
        @web_people   = MyRepresentatives::Commonwealth::WebUpper.new.people
        @email_people = MyRepresentatives::Commonwealth::CSVEmail.new.people
        @people = []
        check_and_update_person
        add_emails_to_person
      end

      private

        def check_and_update_person
          @csv_people.each do |person|
            if @web_people.any? { |wp| wp.phone == person.phone} || @web_people.any? { |wp| wp.email == person.email}
              index = @web_people.find_index {|wp| wp.phone == person.phone}

              if !index
                index = @web_people.find_index { |wp| wp.email == person.email }
              end

              if index
                person.email            = @web_people[index].email
                person.homepage_url     = @web_people[index].homepage_url
                person.image_url        = @web_people[index].image_url
                person.successful_merge = true
              end

            end
            @people << person
          end
        end

        def add_emails_to_person
          @people.each do |person|
            if @email_people.any? { |ep| ep.phone == person.phone} && person.email.nil?
              index = @email_people.find_index {|ep| ep.phone == person.phone}

              if index
                person.email        = @email_people[index].email
              end

            end
          end
        end


    end # MergeLower
  end # Commonwealth
end # MyRepresentatives
