module MyRepresentatives
  class Electorate
    class Error < StandardError; end
    class ElectorateNameMissingError < Error; end
    class StateNameMissingError < Error; end
    class StateNameInvalidError < Error; end

    include MyRepresentatives::Hashable

    attr_accessor :name, :house, :state, :lower_house, :state_government

    def initialize(name)
      raise ElectorateNameMissingError unless name && name.is_a?(String)
      @name = name
    end

    def to_hash
      super
    end

    def commonwealth_lower!(state)
      raise StateNameMissingError unless state
      raise StateNameInvalidError unless MyRepresentatives::Static::STATES.include?(state)
      self.name             = self.name
      self.house            = "House of Representatives"
      self.state            = state
      self.state_government = false
      self.lower_house      = true
    end

    def commonwealth_upper!(state)
      raise StateNameMissingError unless state
      raise StateNameInvalidError unless MyRepresentatives::Static::STATES.include?(state)
      self.name             = self.name
      self.house            = "Senate"
      self.state            = state
      self.state_government = false
      self.lower_house      = false
    end

    def state_act_lower!
      self.name             = self.name
      self.house            = "Legislative Assembly"
      self.state            = "ACT"
      self.state_government = true
      self.lower_house      = true
    end

    def state_nsw_lower!
      self.name             = self.name
      self.house            = "Legislative Assembly"
      self.state            = "NSW"
      self.state_government = true
      self.lower_house      = true
    end

    def state_nsw_upper!
      self.name             = self.name
      self.house            = "Legislative Council"
      self.state            = "NSW"
      self.state_government = true
      self.lower_house      = false
    end

    def state_nt_lower!
      self.name             = self.name
      self.house            = "Legislative Assembly"
      self.state            = "NT"
      self.state_government = true
      self.lower_house      = true
    end

    def state_qld_lower!
      self.name             = self.name
      self.house            = "Legislative Assembly"
      self.state            = "QLD"
      self.state_government = true
      self.lower_house      = true
    end

    def state_sa_lower!
      self.name             = self.name
      self.house            = "House of Assembly"
      self.state            = "SA"
      self.state_government = true
      self.lower_house      = true
    end

    def state_sa_upper!
      self.name             = self.name
      self.house            = "Legislative Council"
      self.state            = "SA"
      self.state_government = true
      self.lower_house      = false
    end

    def state_tas_lower!
      self.name             = self.name
      self.house            = "House of Assembly"
      self.state            = "TAS"
      self.state_government = true
      self.lower_house      = true
    end

    def state_tas_upper!
      self.name             = self.name
      self.house            = "Legislative Council"
      self.state            = "TAS"
      self.state_government = true
      self.lower_house      = false
    end

    def state_vic_lower!
      self.name             = self.name
      self.house            = "Legislative Assembly"
      self.state            = "VIC"
      self.state_government = true
      self.lower_house      = true
    end

    def state_vic_upper!
      self.name             = self.name
      self.house            = "Legislative Council"
      self.state            = "VIC"
      self.state_government = true
      self.lower_house      = false
    end

    def state_wa_lower!
      self.name             = self.name
      self.house            = "Legislative Assembly"
      self.state            = "WA"
      self.state_government = true
      self.lower_house      = true
    end

    def state_wa_upper!
      self.name             = self.name
      self.house            = "Legislative Council"
      self.state            = "WA"
      self.state_government = true
      self.lower_house      = false
    end

  end
end
