module MyRepresentatives
  module NSW
    class MergeLower
      attr_accessor :csv_people, :web_people, :people

      def initialize
        @csv_people   = MyRepresentatives::NSW::CSVLower.new.people
        @web_people   = MyRepresentatives::NSW::WebLower.new.people
        @people = []
        check_and_update_person
      end

      private

        def check_and_update_person
          @csv_people.each do |person|
            if @web_people.any? { |wp| wp.phone == person.phone} || @web_people.any? { |wp| wp.email == person.email}
              index = @web_people.find_index {|wp| wp.phone == person.phone}

              if !index
                index = @web_people.find_index { |wp| wp.email == person.email }
              end

              if index
                person.formal_name      = @web_people[index].formal_name
                person.first_name       = @web_people[index].first_name
                person.preferred_name   = @web_people[index].preferred_name
                person.email            = @web_people[index].email unless person.email
                person.homepage_url     = @web_people[index].homepage_url
                person.image_url        = @web_people[index].image_url
                person.successful_merge = true
              end

            end
            @people << person
          end
        end

    end # MergeLower
  end # NSW
end # MyRepresentatives
