module MyRepresentatives
  module NT
    class WebIndex
      attr_accessor :index_url, :document, :lower_urls

      def initialize
        @logger     = Logger.new(STDOUT)
        @lower_urls = []

        # Lower House
        @index_url = "https://parliament.nt.gov.au/members-of-parliament/members-by-name"
        @document  = find_representatives
        representative_urls_from_document

      end


      private

        def find_representatives
          begin
            request = open(@index_url)
            Nokogiri::HTML(request)
          rescue SocketError => err
            @logger.debug("Unable to connect to #{@index_url}")
            raise err
          end
        end

        def representative_urls_from_document
          begin
            representatives = @document.css(".content-body").css("h3")
          rescue
          end

          representatives.each do |row|
            begin
              @lower_urls  << row.css("a").attr("href").value.strip
            rescue
            end
          end
        end

    end # WebIndex
  end # NT
end # MyRepresentatives
