module MyRepresentatives
  module QLD
    class WebIndex
      attr_accessor :index_url, :document, :lower_urls

      def initialize
        @logger     = Logger.new(STDOUT)
        @lower_urls = []

        # Lower House
        @index_url = "https://www.parliament.qld.gov.au/members/current/list"
        @document  = find_representatives
        representative_urls_from_document

      end


      private

        def find_representatives
          begin
            request = open(@index_url)
            Nokogiri::HTML(request)
          rescue SocketError => err
            @logger.debug("Unable to connect to #{@index_url}")
            raise err
          end
        end


        def representative_urls_from_document
          begin
            representatives = @document.css("select")[1].children
          rescue
          end

          representatives.each do |row|
            begin
              @lower_urls  << "https://www.parliament.qld.gov.au"+row.attr('value') if row.attr('value').include? "MemberDetails?ID="
            rescue
            end
          end
        end

    end # WebIndex
  end # QLD
end # MyRepresentatives
