module MyRepresentatives
  module SA
    class WebIndexUpper
      attr_accessor :index_url, :document, :upper_urls

      def initialize
        @logger     = Logger.new(STDOUT)
        @upper_urls = []

        # Upper House
        @index_url = "http://www2.parliament.sa.gov.au/Internet/DesktopModules/memberlist.aspx?sort=name&house=LC"
        @document  = find_representatives
        representative_urls_from_document

      end


      private

        def find_representatives
          begin
            request = open(@index_url)
            Nokogiri::HTML(request)
          rescue SocketError => err
            @logger.debug("Unable to connect to #{@index_url}")
            raise err
          end
        end


        def representative_urls_from_document
          begin
            @document.css("table#list").css("a").each do |link|
              uri = link.attr("href")
              @upper_urls << "http://www2.parliament.sa.gov.au/Internet/DesktopModules/#{uri}" if uri.include?("MemberDrill.aspx?pid=")
            end
          rescue
          end
        end

    end # WebIndex
  end # QLD
end # MyRepresentatives
