module MyRepresentatives
  module VIC
    class MergeUpper
      attr_accessor :csv_people, :web_people, :people

      def initialize
        @csv_people   = MyRepresentatives::VIC::CSVUpper.new.people
        @web_people   = MyRepresentatives::VIC::WebUpper.new.people
        @people = []
        check_and_update_person
      end

      private

        def check_and_update_person
          @csv_people.each do |person|
            if @web_people.any? { |wp| wp.phone == person.phone} || @web_people.any? { |wp| wp.email == person.email}
              index = @web_people.find_index {|wp| wp.phone == person.phone}

              if !index
                index = @web_people.find_index { |wp| wp.email == person.email }
              end

              if index
                person.homepage_url     = @web_people[index].homepage_url
                person.image_url        = @web_people[index].image_url
                person.successful_merge = true
              end

            end
            @people << person
          end
        end

    end # MergeUpper
  end # VIC
end # MyRepresentatives
