module MyRepresentatives
  module VIC
    class WebIndex
      attr_accessor :index_url, :document, :upper_urls, :lower_urls

      def initialize
        @logger       = Logger.new(STDOUT)
        @index_url    = nil
        @document     = nil
        @lower_urls  = []
        @upper_urls = []

        (1..3).each do |page|
          @index_url = "http://www.parliament.vic.gov.au/members/results?house=Legislative+Assembly&page=#{page}"
          @document  = find_representatives
          representative_urls_from_document( { lower_house: true } )
        end

        (1..2).each do |page|
          @index_url = "http://www.parliament.vic.gov.au/members/results?house=Legislative+Council&page=#{page}"
          @document  = find_representatives
          representative_urls_from_document( { lower_house: false } )
        end
      end


      private

        def find_representatives
          begin
            request = open(@index_url)
            Nokogiri::HTML(request)
          rescue SocketError => err
            @logger.debug("Unable to connect to #{@index_url}")
            raise err
          end
        end

        def representative_urls_from_document(options = { lower_house: true } )
          begin
            results = @document.css("div.results-list")
            representatives = results.css("div.result-item") if results
          rescue
          end

          representatives.each do |row|
            begin
              uri = "http://www.parliament.vic.gov.au" + row.css("h2").css("a").first.attr("href")
              @lower_urls  << uri if options[:lower_house] unless uri.include?("vacant")
              @upper_urls << uri if !options[:lower_house] unless uri.include?("vacant")
            rescue
            end
          end
        end

    end # WebIndex
  end # VIC
end # MyRepresentatives
