module MyRepresentatives
  module WA
    class MergeLower
      attr_accessor :csv_people, :web_people, :people

      def initialize
        @csv_people   = MyRepresentatives::WA::CSVLower.new.people
        @web_people   = MyRepresentatives::WA::WebLower.new.people
        @people = []
        check_and_update_person
      end

      private

        def check_and_update_person
          @csv_people.each do |person|
            index = @web_people.find_index {|wp| wp.email == person.email}

            if !index
              index = @web_people.find_index {|wp| wp.first_name == person.first_name && wp.last_name == person.last_name }
            end

            if !index
              index = @web_people.find_index {|wp| wp.preferred_name == person.first_name && wp.last_name == person.last_name }
            end

            if index
              person.phone            = @web_people[index].phone
              person.party_name       = @web_people[index].party_name
              person.preferred_name   = @web_people[index].preferred_name
              person.homepage_url     = @web_people[index].homepage_url
              person.image_url        = @web_people[index].image_url
              person.successful_merge = true
            end
            @people << person if person
          end
        end

    end # MergeLower
  end # WA
end # MyRepresentatives
