module MyRepresentatives
  module WA
    class WebIndex
      attr_accessor :index_url, :document, :upper_urls, :lower_urls

      def initialize
        @logger       = Logger.new(STDOUT)
        @index_url    = nil
        @document     = nil
        @lower_urls  = []
        @upper_urls = []

        @index_url = "http://www.parliament.wa.gov.au/parliament/memblist.nsf/WAllMembers"
        @document  = find_representatives
        representative_urls_from_document
      end


      private

        def find_representatives
          begin
            request = open(@index_url)
            Nokogiri::HTML(request)
          rescue SocketError => err
            @logger.debug("Unable to connect to #{@index_url}")
            raise err
          end
        end

        def representative_urls_from_document
          begin
            links = @document.css('//a[@href*="WAllMembersFlat"]')
            links.map do |link|
              url = 'http://www.parliament.wa.gov.au'+link['href'].gsub("\\","/")
              @lower_urls << url if link.parent.text.include?("MLA") && !@lower_urls.include?(url)
              @upper_urls << url if link.parent.text.include?("MLC") && !@upper_urls.include?(url)
            end
          rescue
          end
        end

    end # WebIndex
  end # WA
end # MyRepresentatives
